List of all members
cgicc::HTMLAtomicElement< Tag > Class Template Reference

Template for concrete atomic HTMLElement subclasses. More...

`#include <cgicc/HTMLAtomicElement.h>`

Inheritance diagram for cgicc::HTMLAtomicElement< Tag >:

## Public Member Functions
Constructors and Destructor
| HTMLAtomicElement ()
| Create a new empty atomic element. More...
| HTMLAtomicElement (const HTMLAttributeList &attributes)
| Create a new element, specifying the HTMLAttributes. More...
virtual | ~HTMLAtomicElement ()
| Destructor. More...
virtual HTMLElement * | clone () const
| Clone this element. More...
virtual const char * | getName () const
| Get the name of this element. More...
Public Member Functions inherited from cgicc::HTMLElement
| HTMLElement (const HTMLElement &element)
| Copy constructor. More...
virtual | ~HTMLElement ()
| Destructor. More...
bool | operator== (const HTMLElement &element) const
| Compare two HTMLElements for equality. More...
bool | operator!= (const HTMLElement &element) const
| Compare two HTMLElements for inequality. More...
HTMLElement & | operator= (const HTMLElement &element)
| Assignment operator. More...
std::string | getData () const
| Get the data contained in this element, if any. More...
EElementType | getType () const
| Get the type of this element. More...
void | setData (const std::string &data)
| Set the data contained in this element. More...
const HTMLElementList * | getEmbedded () const
| Get the HTMLElementList embedded in this element, if any. More...
void | setEmbedded (const HTMLElementList &embedded)
| Set the HTMLElementList associated with this element. More...
HTMLElement & | add (const HTMLElement &element)
| Add an embedded HTMLElement in this one. More...
HTMLElement & | add (HTMLElement *element)
| Add an embedded HTMLElement in this one. More...
const HTMLAttributeList * | getAttributes () const
| Get the attributes associated with this element. More...
void | setAttributes (const HTMLAttributeList &attributes)
| Set the attributes associated with this element. More...
HTMLElement & | set (const std::string &name)
| Set an HTMLAttribute on this HTMLElement. More...
HTMLElement & | set (const std::string &name, const std::string &value)
| Set an HTMLAttribute on this HTMLElement. More...
virtual void | swapState () const
| Swap the state of the boolean element. More...
virtual bool | getState () const
| Get the state of this boolean element. More...
virtual void | render (std::ostream &out) const
| Render this HTMLElement to an ostream. More...
Public Member Functions inherited from cgicc::MStreamable
| MStreamable ()
| Empty constructor. More...
virtual | ~MStreamable ()
| Empty destructor. More...
virtual void | render (std::ostream &out) const =0
| Write this object to a stream. More...

## Additional Inherited Members
Public Types inherited from cgicc::HTMLElement
enum | EElementType { eAtomic , eBoolean }
| Possible types of HTMLElements. More...
Protected Member Functions inherited from cgicc::HTMLElement
| HTMLElement (const HTMLAttributeList *attributes, const HTMLElement *embedded, const std::string *data, EElementType type)
| Subclass constructor. More...
bool | dataSpecified () const
| For subclasses only. More...

## Detailed Description

template<class Tag>
class cgicc::HTMLAtomicElement< Tag >

Template for concrete atomic HTMLElement subclasses.

An atomic HTML element is an element in which the opening and closing tags are combined. For example, in the HTML code

    <meta link="made" href="mailto:sbooth@gnu.org" />

The `meta` tag is an atomic HTML element because the opening and closing tags appear together.

See also
  HTMLElement
  HTMLBooleanElement

Definition at line 56 of file HTMLAtomicElement.h.

## Constructor & Destructor Documentation

## ◆ HTMLAtomicElement() [1/2]

template<class Tag >

cgicc::HTMLAtomicElement< Tag >::HTMLAtomicElement | ( |  | ) |
| inline

Create a new empty atomic element.

Definition at line 69 of file HTMLAtomicElement.h.

## ◆ HTMLAtomicElement() [2/2]

template<class Tag >

cgicc::HTMLAtomicElement< Tag >::HTMLAtomicElement | ( | const HTMLAttributeList & | attributes | ) |
| inline

Create a new element, specifying the HTMLAttributes.

Parameters

  attributes | The HTMLAttributes contained within the element.

Definition at line 78 of file HTMLAtomicElement.h.

## ◆ ~HTMLAtomicElement()

template<class Tag >

virtual cgicc::HTMLAtomicElement< Tag >::~HTMLAtomicElement | ( |  | ) |
| inline virtual

Destructor.

Definition at line 87 of file HTMLAtomicElement.h.

## Member Function Documentation

## ◆ clone()

template<class Tag >

virtual HTMLElement * cgicc::HTMLAtomicElement< Tag >::clone | ( |  | ) | const
| inline virtual

Clone this element.

Returns
  A newly-allocated copy of this element

Implements cgicc::HTMLElement.

Definition at line 97 of file HTMLAtomicElement.h.

## ◆ getName()

template<class Tag >

virtual const char * cgicc::HTMLAtomicElement< Tag >::getName | ( |  | ) | const
| inline virtual

Get the name of this element.

For example, `meta`.

Returns
  The name of this element

Implements cgicc::HTMLElement.

Definition at line 108 of file HTMLAtomicElement.h.

The documentation for this class was generated from the following file:

- HTMLAtomicElement.h